from __future__ import annotations

from collections.abc import Mapping
from typing import Any, TypeVar

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

T = TypeVar("T", bound="RCInfo")


@_attrs_define
class RCInfo:
    """
    Attributes:
        preproc (str | Unset):
        sort (str | Unset):
        postproc (str | Unset):
    """

    preproc: str | Unset = UNSET
    sort: str | Unset = UNSET
    postproc: str | Unset = UNSET
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        preproc = self.preproc

        sort = self.sort

        postproc = self.postproc

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if preproc is not UNSET:
            field_dict["preproc"] = preproc
        if sort is not UNSET:
            field_dict["sort"] = sort
        if postproc is not UNSET:
            field_dict["postproc"] = postproc

        return field_dict

    @classmethod
    def from_dict(cls: type[T], src_dict: Mapping[str, Any]) -> T:
        d = dict(src_dict)
        preproc = d.pop("preproc", UNSET)

        sort = d.pop("sort", UNSET)

        postproc = d.pop("postproc", UNSET)

        rc_info = cls(
            preproc=preproc,
            sort=sort,
            postproc=postproc,
        )

        rc_info.additional_properties = d
        return rc_info

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
